#include "Sprite.h"
#include "Chars.h"
#include "VVram.h"
#include "Vram.h"

extern byte[] SpriteChars;

constexpr byte InvalidY = 0xe0;

struct Sprite {
    byte x, y;
    byte oldX, oldY;
    byte[4] chars;
};
Sprite[SpriteCount] Sprites;

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->y = InvalidY;
        p->oldY = InvalidY;
    }
}


void ShowSprite(byte index, byte x, byte y, byte code)
{
    ptr<Sprite> p;
    ptr<byte> pSource, pDestination;
    p = Sprites + index;
    p->x = x;
    p->y = y;
    pSource = SpriteChars + code;
    pDestination = p->chars;
    repeat(4) {
        *pDestination = *pSource;
        ++pSource;
        ++pDestination;
    }
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->y = InvalidY;
}

void EraseSprites() 
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->oldY != InvalidY && (
            p->oldX != p->x || 
            p->oldY != p->y
        )) {
            word offset;
            ptr<byte> pFront, pBack;
            byte y;
            y = p->oldY;
            offset = VVramOffset(p->oldX, y);
            pFront = VVramFront + offset;
            pBack = VVramBack + offset;
            repeat (2) {
                repeat (2) {
                    *pFront = *pBack;
                    ++pFront;
                    ++pBack;
                }
                pFront += VVramWidth - 2;
                pBack += VVramWidth - 2;
            }
            SetRowFlags(y, 3);
        }
    }
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->y != InvalidY) {
            ptr<byte> pFront, pChar;
            byte y;
            y = p->y;
            pFront = VVramFront + VVramOffset(p->x, y);
            pChar = p->chars;
            repeat (2) {
                repeat (2) {
                    byte c;
                    c = *pChar; ++pChar;
                    if (c != 0) {
                        *pFront = c;
                    }
                    ++pFront;
                }
                pFront += VVramWidth - 2;
            }
            SetRowFlags(y, 3);
        }
        p->oldX = p->x;
        p->oldY = p->y;
    }
}
